var before = 0;
var after = 0;
apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
            deleTimer:null,
            deleClick:false,
            deleItem:null,
            pageShareType: 'index_wzxq',
            showTabBar: true,
            tabActive: 2,
            currentBannerId: 0,
            qipuList: [],
            pageIndex: 1,
            loading: true,
            finished: false,
            isLoading: false,
            indexTab: true, //右下角圆圈
            beforeTop: 0,
            afterTop: 0,
            target: '',
            loadEnd: false,
            qipanLoading: true,
            nowDays: {
                year: '',
                month: '',
                day: ''
            },
            topTab: [
                { text: '棋力评测', class: 'gra_blue', icon: 'iconduizhanpingtai', url: 'play_chess/qlcp' },
                { text: '好友对战', class: 'gra_orange', icon: 'iconhaoyouduizhan', url: 'play_chess/create_room' },
                { text: 'AI博弈', class: 'gra_purple', icon: 'iconai1', url: 'play_chess/ai' },
                { text: '棋社', class: 'gra_blue', icon: 'iconshequ4', url: 'play_chess/association' },
                { text: '人机对战', class: 'gra_purple', icon: 'iconjiqiren1', url: 'chess/ai' },
                { text: 'AI分析', class: 'gra_green', icon: 'iconcaidanlanfupanlanse', url: 'chess/analyse' },
                { text: '排行榜', class: 'gra_blue', icon: 'iconpaihangbang1', url: 'play_chess/rank_list' },
                { text: '我的棋谱', class: 'gra_red', icon: 'iconwenkuguanli', url: 'frame/frame4' },
            ],
            bannerList: [],
            connected: false, //监控ws是否已经连接成功
            mySwiper: '',
            winWidth: 0,
            newMessage: 0
        },
        created: function () {
            var _this = this;
            this.init();
            this.initData();
            this.initDays();
            this.initMessage();
            this.getUserInfo();
            api.addEventListener({
                name: 'refreshQipu'
            }, function (ret, err) {
                if (ret) {
                    _this.onRefresh();
                }
            });
            document.getElementById('loading').innerText = '';

        },
        methods: {
            initMessage: function () {
                mySendMessage(mysetting.routes.getMessageNums, {}, function (data) {
                    if (data.errno == 0) {
                        vue.newMessage = data.data.nums;
                        api.setAppIconBadge({
                            badge: data.data.nums
                        });
                    }
                });
            },
            initData: function () {
                this.ajaxPost(xqwxt_url + "&do=common&op=getChessBanner", {}, function (vm, ret) {
                    vm.bannerList = ret.data.banner;
                    vm.topTab = ret.data.topTab;
                    setTimeout(function () {
                        if (vm.mySwiper) {
                            vm.mySwiper.update()
                        } else {
                            vm.mySwiper = new Swiper('.my-swipe', {
                                loop: true,
                                autoplay: {
                                    delay: 2500,
                                    disableOnInteraction: false,//用户操作swiper之后是否禁止自动切换
                                },
                                pagination: {
                                    el: '.swiper-pagination',
                                }
                            })
                        }
                    }, 100)
                })
            },
            clickBanner: function (item) {
                if (!item) return;
                if (item.type == 'window') {
                    this.openPage(item.path, item.params);
                } else {
                    var browser = api.require('webBrowser');
                    if (item.path.indexOf('?') == -1) {
                        browser.open({
                            url: item.path + '?appuid=' + this.memberinfo.uid
                        });
                    } else {
                        browser.open({
                            url: item.path + '&appuid=' + this.memberinfo.uid
                        });
                    }

                }
            },
            onChange: function (index) {
                this.currentBannerId = index;
            },
            onRefresh: function () {
                var _this = this;
                this.pageIndex = 1;
                this.finished = false;
                this.initData();
                setTimeout(function () {
                    _this.getList(1);
                }, 300);
            },
            getList: function (type) {
                var _this = this;
                mySendMessage(mysetting.routes.getChesses, {
                    page: _this.pageIndex,
                    psize: 10,
                    isNew: 1
                }, function (ret) {
                    if (ret.errno == 0) {
                        if (_this.pageIndex == 1) {
                            _this.qipuList = [];
                        }
                        for (var i = 0; i < ret.data.length; i++) {
                            ret.data[i].result={
                                'win':0,
                                'lose':0,
                                'draw':0
                            }
                            for (var j = 0; j < ret.data[i].day.length; j++) {
                                if((ret.data[i]['day'][j]['result']==1 && ret.data[i]['day'][j]['reduid']==uid) || (ret.data[i]['day'][j]['result']==2 && ret.data[i]['day'][j]['reduid'] != uid )  ){
                                    ret.data[i].result['win']++
                                }else if( (ret.data[i]['day'][j]['result']==2 && ret.data[i]['day'][j]['reduid']==uid ) || (ret.data[i]['day'][j]['result']==1 && ret.data[i]['day'][j]['reduid'] != uid )  ){
                                    ret.data[i].result['lose']++
                                }else if(ret.data[i]['day'][j]['result']==3){
                                    ret.data[i].result['draw']++
                                }
                                var tempItem = ret.data[i].day[j];
                                if (tempItem.reduid == uid) {
                                    initialization(_this.target, 'tempCanvas' + '', board2map(tempItem.fen, 1));
                                } else {
                                    initialization(_this.target, 'tempCanvas' + '', arrReverse(board2map(tempItem.fen, 1)), 0, 1);
                                }
                                _this.$refs['tempCanvas'].width = 72 * 5;
                                _this.$refs['tempCanvas'].height = 83 * 5;
                                stage2.scaleX = stage2.scaleY = 0.5;
                                stage2.update();
                                ret.data[i].day[j].src = stage2.toDataURL();
                            }
                            if((i+1) == ret.data.length  && typeof ret.data[i].strengthPlus === "undefined"  ){
                                ret.data[i].strengthPlus=ret.data[i].strength-1500
                            }
                            if (_this.qipuList.length != 0 && _this.qipuList[_this.qipuList.length - 1].days == ret.data[i].days) {
                                for (var k = 0; k < ret.data[i].day.length; k++) {
                                    _this.qipuList[_this.qipuList.length - 1].day.push(ret.data[i].day[k])
                                }
                                _this.qipuList[_this.qipuList.length - 1]['result']['win'] += ret.data[i].result['win']
                                _this.qipuList[_this.qipuList.length - 1]['result']['lose'] += ret.data[i].result['lose']
                                _this.qipuList[_this.qipuList.length - 1]['result']['draw'] += ret.data[i].result['draw']
                              //  _this.qipuList[_this.qipuList.length - 1].strengthPlus +=  ret.data[i].strength
                            } else {
                                _this.qipuList.length > 0 ? _this.qipuList[_this.qipuList.length - 1].strengthPlus = _this.qipuList[_this.qipuList.length - 1].strength - ret.data[i].strength : '';
                                _this.qipuList.push(ret.data[i]);
                            }
                        }
                        _this.loading = false;
                        _this.isLoading = false;
                        _this.finished = false;
                        _this.pageIndex++;
                    } else {
                        _this.loading = false;
                        _this.isLoading = false;
                        _this.finished = true;
                    }
                })

            },
            getResultStr(result){
                let msg=''
                if(result['win']){
                    msg = result['win']+"胜"
                }
                if(result['lose']){
                    msg += (result['win']?"/":"") + result['lose']+"负"
                }
                if(result['draw']){
                    msg += (result['lose']?"/":"") + result['draw']+"和"
                }
                return msg
            },
            touchDele:function(e,item){
                // e.preventDefault();
                 let _this=this
                 _this.deleItem=item
                 _this.deleClick = false 
                  _this.deleTimer = setTimeout(function(){
                 _this.deleClick=true
                 _this.$dialog.confirm({
                     title: '删除棋谱',
                     message: '确认删除棋谱吗？',
                     closeOnClickOverlay:true
                 }).then(function() {
              
                     _this.ajaxPost(xqwxt_url+'&op=delete_index_chess&do=chess', { chessid: _this.deleItem.id }, function(vm,data) {
                        // data = $.parseJSON(data);
                         console.log(data.message,123456);
                         vm.$toast({
                             message: data.message,
                         })
                         setTimeout(function(){
                             _this.pageIndex = 1;
                             _this.getList(1);
                         },1000)
                     });
                 }).catch(() => {
                    // on cancel
                    console.log('取消')
                  });
                  },500)
                 return false
             },
             touchDeleMove(){
                 clearTimeout(this.deleTimer)
                 this.deleClick=true
                 
             },
             touchDeleEnd(){
             
                 clearTimeout(this.deleTimer)
                 if(!this.deleClick){
                     this.openPage('chess/chess', {role: (this.deleItem.reduid==this.uid?1:2), chessid: this.deleItem.id })
                 }
                 
             },
            initDays: function () {
                var now = new Date();
                this.nowDays.year = now.getFullYear();
                this.nowDays.month = now.getMonth() + 1;
                this.nowDays.day = now.getDate();
            },
            handleScroll: function (e) {
                this.afterTop = e.target.documentElement.scrollTop || e.target.body.scrollTop;
                if (this.afterTop <= this.beforeTop) {
                    this.indexTab = true;
                    this.beforeTop = this.afterTop;
                } else {
                    this.indexTab = false;
                    this.beforeTop = this.afterTop;
                }
            },
            init: function () {
                var loader = new createjs.LoadQueue(false, null, "");
                loader.on("fileload", this.handleFileLoad);
                loader.on("complete", this.handleComplete);
                loader.loadFile({ src: "../../script/util/ZobristTable.js" });
                loader.loadFile({ src: "../../script/lib/easeljs.min.js", id: 'Easeljs' });
                loader.loadFile({ src: "../../script/lib/tweenjs.min.js" });
                loader.loadFile({ src: "../../script/Model.js" });
                loader.loadFile({ src: "../../script/View.js" });
                loader.loadFile({ src: "../../script/Control.js" });
                loader.loadFile({ src: "../../script/Player.js" });
                loader.loadFile({ src: "../../script/Chess.js" });
                loader.loadFile({ src: "../../script/lib/gameRes.js" });
                loader.loadManifest([
                    { src: "../../assets/images/board.png", id: "Board", loadTimeout: 20000 },
                    { src: "../../assets/images/border1.png", id: "Border1", loadTimeout: 20000 },
                    { src: "../../assets/images/border2.png", id: "Border2", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical1.png", id: "Vertical1", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical2.png", id: "Vertical2", loadTimeout: 20000 }
                ]);
            }, //初始化加载资源
            handleFileLoad: function (evt) {
                if (evt.item.type == "image") {
                    images[evt.item.id] = evt.result;
                }
                if (evt.item.id == 'Easeljs') {
                    chessList = new createjs.SpriteSheet(CHESS_SLIM);
                    effectList = new createjs.SpriteSheet(F_ATLAS);
                }
            },
            handleComplete: function (evt) {
                if (chessList.complete && effectList.complete) {
                    this.target = evt;
                    this.loadEnd = true;
                    this.qipanLoading = false;
                    this.getList();
                } else {
                    chessList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                    effectList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                }
            }
        },
    });
}